/* include/outils.h - Divers outils
 *
 * Copyright (C) 2002-2005 David Cortier  <Cesar@irc.jeux.fr>
 *                         Romain Bignon  <Progs@kouak.org>
 *                         Benjamin Beret <kouak@kouak.org>
 *
 * site web: http://sf.net/projects/scoderz/
 *
 * Services pour serveur IRC. Support sur IrcProgs et IRCoderz
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * $Id: outils.h,v 1.23 2005/05/06 22:56:10 romexzf Exp $
 */

#ifndef HAVEINC_outils
#define HAVEINC_outils

#define LISTSEP ','

extern int match(const char *, const char *); /* hack*/
extern int mmatch(const char *, const char *); /* hack*/

extern int chan_check(const char *, aNick *);
extern int is_num(const char *);
extern int is_ip(const char *);
extern void strupr(char *);
extern void strlwr(char *);
extern void strip_newline(char *);

extern int getoption(const char *, char **, int, int, int);

extern int split_buf(char *, char **, int);
extern void parv2msgn(int, char **, int, char *, int);
extern char *parv2msg(int, char **, int, int);

extern char *duration(int);
extern time_t convert_duration(const char *);
extern char *get_time(aNick *, time_t);

extern char *GetNUHbyNick(aNick *, int);
extern char *GetPrefix(aNick *);
extern char *GetChanPrefix(aNick *, aJoin *);
extern char *GetUserOptions(anUser *);
extern char *GetAccessOptions(anAccess *);
extern char *GetChanOptions(aChan *);
extern char *GetIP(const char *);

extern void putlog(const char *, const char *, ...);
extern int check_protect(aNick *, aNick *, aChan *);

extern int parse_umode(int, const char *);
extern char *GetModes(int);
extern int cmodetoflag(int, const char *);
extern int string2scmode(struct cmode *, const char *, const char *, const char *);
extern char *GetCModes(struct cmode);
extern void floating_limit_update_timer(aChan *);

extern int IsValidNick(char *);
extern int IsValidMail(char *);

extern char *RealCmd(const char *);

extern anUser *ParseNickOrUser(aNick *, char *);

extern char *str_dup(char **, const char *);
extern char *Strncpy(char *, const char *, size_t);
extern char *Strtok(char **, char *, int);

extern int switch_option(aNick *, const char *, const char *, const char *, int *, int);

extern int cswall(const char *, ...);
extern int fastfmt(char *, const char *, ...);
extern int fastfmtv(char *, const char *, va_list);

extern int item_isinlist(const int *, const int, const int);
extern int item_parselist(char *, int *, const int);

#endif /*HAVEINC_outils*/
