/* include/structs.h - Dclaration des diffrentes structures
 * Copyright (C) 2002-2005 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifdef SQLLOG
#include <mysql.h>
#endif

/*------------------- Structures robot -------------------*/
struct robot {
  char server[HOSTLEN + 1];
  char servnum[NUMSERV + 1];
  char pass[21];
  int port;
  char name[REALEN + 1];
  char ip[16];
  char chan[REGCHANLEN + 1];
  char pchan[REGCHANLEN + 1];
  char cara;
  int sock;
  time_t uptime;
  time_t lasttime; /* pour traffic */
  unsigned long int lastbytes;	/*  idem */
  unsigned long int dataS; /* bytes envoyes depuis le dbut */
  unsigned long int dataQ; /* bytes reues */

#ifdef SQLLOG
	MYSQL *sql_id;
	char *sql_host;
	int sql_port;
	char sql_db[30];
	char sql_user[30];
	char sql_pass[30];
#endif

#ifdef WEB2CS
	int w2c_port;
	int CONtotal;
	char w2c_pass[16 + 1];
	unsigned int WEBtrafficUP;
	unsigned int WEBtrafficDL;
#endif
};

struct bots {
  char nick[NICKLEN + 1];
  char ident[USERLEN + 1];
  char host[HOSTLEN + 1];
  char name[REALEN + 1];
  char mode[10];
  char num[2 * (NUMSERV + 1)];
};

enum TimerType {TIMER_ABSOLU, TIMER_RELATIF, TIMER_PERIODIC};

typedef struct Timer {
	time_t expire;
	time_t delay;
	enum TimerType type;
	int (*callback) (struct Timer *);
	void *data1;
	void *data2;
	struct Timer *last;
	struct Timer *next;
} Timer;

struct suspendinfo {
	char from[NICKLEN + 1];
	char raison[251];
	time_t expire;
	time_t debut;
	Timer *timer;
	void *data;
};

/*------------------- Structures informations serveurs -------------------*/

typedef struct Link {
	char serv[HOSTLEN + 1];
	char num[NUMSERV + 1];
	int maxusers;
	int smask;
	int flag;
#define ST_BURST 	0x01
#define ST_ONLINE 	0x02
#define ISHUB 		0x04
	struct Link *hub;
} aServer;

/*------------------- Structures users et accs -------------------*/
typedef struct nickinfo {
	char nick[NICKLEN + 1];
	char ident[USERLEN + 1];
	char host[HOSTLEN + 1];
#ifdef HAVE_CRYPTHOST
	char crypt[HOSTLEN + 1];
#endif
	struct Link *serveur;
	char name[REALEN + 1];
	char base64[7];
	char numeric[2 * (NUMSERV + 1 )];
	unsigned int flag;
#define N_REGISTER 	0x00001
#define N_AWAY 		0x00002
#define N_OPER 		0x00004
#define N_SERVICE 	0x00008
#define N_ADM 		0x00010
#define N_INV 		0x00020
#define N_GOD 		0x00040
#define N_WALLOPS 	0x00080
#define N_DEBUG 	0x00100
#define N_FEMME 	0x00200
#define N_HOMME 	0x00400
#define N_CRYPT 	0x00800
#define N_REG 		0x01000
#define N_DIE 		0x02000
#define N_DEAF 		0x04000
#define N_SPOOF 	0x08000
#define N_HASKILL 	0x10000
#define N_UMODES (N_INV |N_CRYPT|N_REG|N_OPER|N_SERVICE|N_ADM|N_GOD \
					|N_FEMME|N_HOMME|N_DEBUG|N_WALLOPS|N_DIE|N_DEAF|N_SPOOF)
	time_t ttmco;
	time_t floodtime;
	unsigned int floodcount;
	Timer *timer;
	struct userinfo *user;
	struct nickinfo *next;
	struct joininfo *joinhead;
} aNick;

typedef struct userinfo {
   char nick[NICKLEN + 1];
   char passwd[PWDLEN + 1];
   int level;
   time_t lastseen;
   int flag;
#define U_PKILL		 0x0001 /* nickserv */
#define U_PNICK		 0x0002 /* nickserv */
#define U_WANTDROP	 0x0004
#define U_NOPURGE	 0x0008
#define U_WANTX		 0x0010
#define U_OUBLI		 0x0020
#define U_FIRST 	 0x0040
#define U_NOMEMO	 0x0080
#define U_PREJECT	 0x0100
#define U_POKACCESS	 0x0200
#define U_PACCEPT	 0x0400
#define U_ALREADYCHANGE	 0x0800
#define U_ADMBUSY 		0x1000
#define U_MD5PASS 		0x2000

#define U_ALL (U_PKILL|U_PNICK|U_WANTDROP|U_NOPURGE|U_WANTX|U_OUBLI|U_FIRST| \
				U_NOMEMO|U_PREJECT|U_POKACCESS|U_PACCEPT|U_ALREADYCHANGE|U_ADMBUSY|U_MD5PASS)
   char mail[MAILLEN + 1];
   char *lastlogin;
   time_t cantregchan;
#ifdef HAVE_VOTE
   int vote;
#endif
   struct Lang *lang;
   struct suspendinfo *suspend;
   struct access *accesshead;
   aNick *n;
#ifdef USE_MEMOSERV
   struct memos *memohead;
#endif
   struct userinfo *next;
} anUser;

typedef struct access {
   struct chaninfo *c; /* pour rediriger vers la struct du chan o on a access.*/
   int level;
   int flag;
#define A_OP		 0x01
#define A_VOICE		 0x02
#define A_PROTECT	 0x04
#define A_SUSPEND	 0x08
#define A_WAITACCESS 0x10
   time_t lastseen;
   char *info;
   struct userinfo *user;
   struct access *next;
} anAccess;

#ifdef USE_MEMOSERV
typedef struct memos {
   char de[NICKLEN + 1];
   time_t date;
   char message[MEMOLEN + 1];
   int flag;
#define MEMO_READ 		0x1
#define MEMO_AUTOEXPIRE 0x2
   struct memos *next;
} aMemo;
#endif

typedef struct aDNR_ {
	char *mask;
	char *raison;
	struct aDNR_ *next;
	struct aDNR_ *last;
	unsigned int flag;
#define DNR_TYPEUSER 0x01
#define DNR_TYPECHAN 0x02
#define DNR_MASK 	0x04
	time_t date;
	char from[NICKLEN + 1];
} aDNR;

/*------------------- Structures chans -------------------*/

struct cmode {
#define C_MMSG 		0x001
#define C_MTOPIC 	0x002
#define C_MINV 		0x004
#define C_MLIMIT 	0x008
#define C_MKEY 		0x010
#define C_MSECRET 	0x020
#define C_MPRIVATE 	0x040
#define C_MMODERATE 0x080
#define C_MNOCTRL 	0x100
#define C_MNOCTCP 	0x200
#define C_MOPERONLY 0x400
#define C_MUSERONLY 0x800
	unsigned int modes; /* modes sous forme de flag*/
	int limit;
	char key[KEYLEN + 1];
};

typedef struct chaninfo {
	char chan[REGCHANLEN + 1];/* infos sur le salon actuel du rseau*/
	char topic[TOPICLEN + 1];
	time_t chanstamp;
	struct cmode mode;
	int users;

	struct cmode defmodes;/* proprits des salons regs*/
	char deftopic[TOPICLEN + 1];
	char welcome[TOPICLEN + 1];
	char description[DESCRIPTIONLEN + 1];
	char *motd;
	char url[81];
	int flag;
#define C_SETWELCOME	0x0001
#define C_JOINED		0x0002
#define C_STRICTOP		0x0004
#define C_LOCKTOPIC		0x0008
#define C_NOBANS		0x0010
#define C_WANTUNREG		0x0020
#define C_NOOPS			0x0040
#define C_AUTOINVITE 	0x0080
#define C_ALREADYRENAME 0x0100
#define C_FLIMIT 		0x0200
	int banlevel;
	int cml;
	int bantype;
	int limit_inc;
	int limit_min;
	time_t bantime;
	time_t creation_time;
	time_t lastact;
	anAccess *owner;
	Timer *timer;
	struct baninfo *banhead;
	struct suspendinfo *suspend;
	struct SLink *access; /* utiliser un link pour avoir la liste des access plus rapidement*/
	struct SLink *members; /* listes ds users dans le chan*/
	struct chaninfo *next;
} aChan;

typedef struct baninfo {
	char nick[NICKLEN + 1];
	char user[USERLEN + 1];
	char host[HOSTLEN + 1];
	char de[NICKLEN + 1];
	char *raison;
	char *mask;
	time_t debut;
	time_t fin;
	int level;
	int flag;
#define BAN_ANICKS 0x1
#define BAN_AUSERS 0x2
#define BAN_AHOSTS 0x4
	Timer *timer;
	struct baninfo *next;
	struct baninfo *last;
} aBan;

typedef struct joininfo
{
   char channel[CHANLEN + 1];
   unsigned short status;
#define J_OP 	0x01
#define J_VOICE 0x02
#define J_BURST 0x04
   time_t timestamp;
   aNick *nick;
   struct chaninfo *chan;
   struct joininfo *next;
} aJoin;

typedef struct Lang {
	char langue[16];
	char *msg[LANGMSGNB];
	int id;
	struct Lang *next;
} Lang;

typedef struct HelpBuf {
	char **buf;
	int count;
} HelpBuf;

/*------------------- Structures flood et kill -------------------*/
#ifdef USE_NICKSERV
enum KillType {TIMER_CHNICK, TIMER_KREGNICK};

typedef struct killinfo {
	aNick *nick;
	enum KillType type;
	struct killinfo *next;
	struct killinfo *last;
} aKill;
#endif

struct ignore {
	char host[7];
	time_t expire;
	struct ignore *next;
	struct ignore *last;
};

/*------------------- Structures parses et cmds -------------------*/

typedef struct aHashCmd {
	char corename[CMDLEN + 1];
	char name[CMDLEN + 1];
	int (*func) (aNick *, aChan *, int, char **);
	char syntax[SYNTAXLEN + 1];
	int level;
	int args;
	int flag;
#define CMD_CHAN 		0x01
#define CMD_ADMIN 		0x02
#define CMD_DISABLE 	0x04
#define CMD_NEEDNOAUTH 	0x08
#define CMD_SECURE 		0x10
#define CMD_SECURE2 	0x20
#define CMD_INTERNAL (CMD_NEEDNOAUTH|CMD_SECURE|CMD_SECURE2|CMD_CHAN)
	int used;
	struct aHashCmd *next;
	HelpBuf **help;
} aHashCmd;

/*------------------- Structures pour les Links -------------------*/

typedef struct SLink {
  struct SLink *next;
  union {
    anAccess *a;
    aJoin *j;
  } value;
} aLink;
