/* include/web2cs.h - Dclarations du Web2CS
 * Copyright (C) 2002-2004 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef HAVEINC_web2cs
#define HAVEINC_web2cs

#ifdef WEB2CS

#define MAXPARAM 16
#define W2CDEBUG
/*#define W2CDEBUGALL*/
#define MAXWEBCON 10
#define W2C_SENDSIZE 1024
#define W2C_RECVSIZE 256
#define W2C_MAXIDLE 10 /* in seconds */

/* structures */
typedef struct WClient {
	int fd; 			/* fd de la connexion */
	unsigned int flag;	/* divers infos */
#define W2C_AUTH 	0x01
#define W2C_FREE 	0x02
#define W2C_FLUSH 	0x04
	char ip[16]; 	/* ip */
	size_t buflen;
	size_t recvlen;
	time_t lastread;
	char QBuf[W2C_SENDSIZE+1];
	char RecvBuf[W2C_RECVSIZE+1];
	anUser *user; 		/* ptr vers la struct user*/
} WClient;

typedef struct w2c_hallow {
	unsigned long int host;
	struct w2c_hallow *next;
} w2c_hallow;

#define IsAuth(x) 		((x)->flag & W2C_AUTH)
#define WSetFlush(x) 	(x)->flag |= W2C_FLUSH
#define WDelFlush(x) 	(x)->flag &= ~W2C_FLUSH
#define WIsFlush(x) 	((x)->flag & W2C_FLUSH)

/* dear global vars */

extern int bind_sock;

extern w2c_hallow *w2c_hallowhead;

extern int w2c_handle_read(int);
extern void w2c_initsocket(void);
extern WClient *w2c_addclient(int, struct in_addr *);
extern void w2c_delclient(WClient *);

#endif
#endif
