/* src/chaninfo.c - Lire les informations  propos d'un salon
 * Copyright (C) 2002-2004 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * $Id: chaninfo.c,v 1.43 2005/01/08 13:52:07 romexzf Exp $
 */

#include "main.h"
#include "outils.h"
#include "ban.h"
#include "cs_cmds.h"
#include "admin_chan.h"
#include "hash.h"

/*
 * chaninfo #salon
 */
int chaninfo(aNick *nick, aChan *chan, int parc, char **parv)
{
	int see = (IsAnAdmin(nick->user) || (nick->user && GetAccessIbyUserI(nick->user, chan)));

	if(HasMode(chan, C_MSECRET | C_MPRIVATE) /* salon +s ou +p */
		&& !see && !GetJoinIbyC(nick, chan)) /* ET ni admin/accs, ni prsent */
			return csntc(nick, GetReply(nick, L_YOUNOACCESSON), chan->chan);

	csntc(nick, GetReply(nick, L_INFO_ABOUT), parv[1]);
	csntc(nick, GetReply(nick, L_CIOWNER), chan->owner ? chan->owner->user->nick : "Aucun",
		chan->creation_time ? get_time(nick, chan->creation_time) : "- Non dfini -");
	csntc(nick, GetReply(nick, L_CIDESCRIPTION), chan->description);

	if(see || !HasDMode(chan, C_MKEY))
		csntc(nick, GetReply(nick, L_CIDEFMODES), GetCModes(chan->defmodes));

	csntc(nick, GetReply(nick, L_CIDEFTOPIC), chan->deftopic);
	if(see && chan->motd) csntc(nick, GetReply(nick, L_CIMOTD), chan->motd);
	csntc(nick, GetReply(nick, L_CICHANURL), chan->url);

	csntc(nick, GetReply(nick, L_CIOPTIONS), GetChanOptions(chan));
	csntc(nick, GetReply(nick, L_CIBANLVL), chan->banlevel, GetBanType(chan));

	csntc(nick, GetReply(nick, L_CICHMODESLVL), chan->cml,
			chan->bantime ? duration(chan->bantime) : "Aucun");

	if(CSetWelcome(chan) && *chan->welcome) csntc(nick, GetReply(nick, L_CIWELCOME), chan->welcome);
	if(IsAnAdmin(nick->user)) show_suspend(nick, chan);
	csntc(nick, GetReply(nick, L_CIACTUALTOPIC), chan->topic);

	if(see || !HasMode(chan, C_MKEY) || GetJoinIbyC(nick, chan))
		csntc(nick, GetReply(nick, L_CIACTUALMODES), chan->mode.modes ? GetCModes(chan->mode) : "Aucun");

	if(IsAnAdmin(nick->user)) whoison(nick, chan, parc, parv);

	return 1;
}
